// This file instantiates and tests the bcdCount module
`timescale 1ns / 1ns
module bcdTest;
	
	reg clk, reset, cen;
	initial begin
		reset <= 1;
		#25 reset <= 0;
	end
	initial begin
		clk <= 1;	
		#1
		repeat (130) begin
			#5
			clk <= ~clk;
			#5
			clk <= ~clk;
		end	 
		$stop;
	end	
	wire [3:0] count1, count0;
	wire tc;
	bcdCount bcd1
		(.clk (clk),
		.reset (reset),
		.cen (tc & cen),
		.count (count1),
		.tc  ( ));
	bcdCount bcd0
		(.clk (clk),
		.reset (reset),
		.cen (cen),
		.count (count0),
		.tc  (tc));
		
	integer i;	
	reg [3:0] good1, good0;
	always @(posedge clk) begin
	   cen <= ($random() & 'hf) != 'he;
	   if (reset) begin
		   good1 <= 0;
		   good0 <= 0;
	   end else if (cen) begin
		   if (good0 == 9) begin
			   good0 <= 0;		 
			   if (good1 == 9) good1 <= 0;
			   else good1 <= good1 + 1;
		   end else begin
		   	good0 <= good0 + 1;
		   end
	   end	   
	   $display("reset=%d, cen=%d, count=%d%d, should be=%d%d",
	             reset, cen, count1, count0, good1, good0);
	   if (good1 !== count1 || good0 !== count0) begin
		   $display("^^^^^^^^^ERROR^^^^^^^^^^");		 
	   end
	end
endmodule
	   
			   